Option Explicit On 
Option Strict On
Option Compare Binary

Imports System
Imports System.Windows.Forms

' <remarks>
'   Hauptformular der Anwendung.
' </remarks>
Public Class MainForm
    Inherits System.Windows.Forms.Form

#Region " Vom Windows Form Designer generierter Code "
    Public Sub New()
        MyBase.New()
        InitializeComponent()
    End Sub

    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    Private components As System.ComponentModel.IContainer

    Friend WithEvents btnButton As System.Windows.Forms.Button
    Friend WithEvents chkCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents lstListBox As System.Windows.Forms.ListBox

    <System.Diagnostics.DebuggerStepThrough()> _
    Private Sub InitializeComponent()
        Me.btnButton = New System.Windows.Forms.Button()
        Me.chkCheckBox = New System.Windows.Forms.CheckBox()
        Me.lstListBox = New System.Windows.Forms.ListBox()
        Me.SuspendLayout()
        '
        'btnButton
        '
        Me.btnButton.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.btnButton.Location = New System.Drawing.Point(16, 16)
        Me.btnButton.Name = "btnButton"
        Me.btnButton.Size = New System.Drawing.Size(80, 24)
        Me.btnButton.TabIndex = 0
        Me.btnButton.Text = "Button"
        '
        'chkCheckBox
        '
        Me.chkCheckBox.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.chkCheckBox.Location = New System.Drawing.Point(16, 56)
        Me.chkCheckBox.Name = "chkCheckBox"
        Me.chkCheckBox.Size = New System.Drawing.Size(96, 20)
        Me.chkCheckBox.TabIndex = 1
        Me.chkCheckBox.Text = "CheckBox"
        '
        'lstListBox
        '
        Me.lstListBox.Location = New System.Drawing.Point(16, 96)
        Me.lstListBox.Name = "lstListBox"
        Me.lstListBox.Size = New System.Drawing.Size(176, 108)
        Me.lstListBox.TabIndex = 2
        '
        'MainForm
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(210, 224)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.lstListBox, Me.chkCheckBox, Me.btnButton})
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.Name = "MainForm"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "MultiEvent"
        Me.ResumeLayout(False)

    End Sub
#End Region

    Private Sub MainForm_Load( _
      ByVal sender As Object, _
      ByVal e As System.EventArgs) _
      Handles MyBase.Load
        Dim i As Integer
        For i = 1 To 20
            lstListBox.Items.Add("Element Nummer " & _
              i.ToString())
        Next i

        ' Hinzufgen der Handler zu den einzelnen 
        ' Steuerelementen; zur Demonstration definieren wir einen
        ' gemeinsamen Handler, der von allen Steuerelementen 
        ' fr entsprechende Ereignisse benutzt wird.
        AddHandler Me.btnButton.Click, AddressOf MultiEvent
        AddHandler Me.lstListBox.Click, AddressOf MultiEvent
        AddHandler Me.chkCheckBox.CheckStateChanged, AddressOf MultiEvent
    End Sub

    Private Sub MultiEvent( _
      ByVal sender As Object, _
      ByVal e As EventArgs)

        ' Ermitteln, zu welchem Steuerelement das Ereignis 
        ' gehrt und Erstellen einer entsprechenden Meldung.
        Dim s As String
        Select Case True
            Case sender Is Me.btnButton
                s = "Der Button wurde geklickt!"
            Case sender Is Me.lstListBox
                s = "Das Element mit dem Titel """ & _
                  Convert.ToString(DirectCast(sender, ListBox).SelectedItem) & _
                  """ wurde aus der ListBox gewhlt!"
            Case sender Is Me.chkCheckBox
                s = "Der Status der CheckBox wurde verndert!"
        End Select
        MessageBox.Show(s, "Ereignis ausgelst")
    End Sub

    Private Sub MainForm_Closing( _
      ByVal sender As Object, _
      ByVal e As System.ComponentModel.CancelEventArgs) _
      Handles MyBase.Closing
        RemoveHandler Me.btnButton.Click, AddressOf MultiEvent
        RemoveHandler Me.lstListBox.Click, AddressOf MultiEvent
        RemoveHandler Me.chkCheckBox.CheckStateChanged, AddressOf MultiEvent
    End Sub
End Class